<?php

if(!file_exists('app/api_config.php')) {
	header('Location: /');
	exit();
}
include('app/api_config.php');
$ini=parse_ini_file('app/config.ini');
$version=$ini['site_version'];
$db_name='cashbox.sqlite';
$url = $api_domen.'/api/update?token='.$api_pass.'&soft=1&version='.$version;
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2);

$json = curl_exec($ch);
curl_close($ch);
$result=json_decode($json, true);
$dir='backups';
$backup_folder=$dir.'/'.date("YmdHi").'/';
$instal=$_GET['instal']; // Какую версию надо установить

$backup=$_GET['backup']; // Надо ли сделать только резервную копию

function backup($folder, $backup_folder, $delete=false) {
	global $db_name;
	$files=scandir($folder);
	foreach ($files as $f) {
		if($f!='.' && $f!='..' && $f!='backups' && $f!='tmp' && $f!='.git') {
			if(!is_dir($folder.$f)) {
				if(!copy($folder.$f, $backup_folder.$f)) {
					echo'<p>Возникала ошибка при копировании файла '.$folder.$f.'</p>';
					exit();
				}
				if($f!='api_config.php' && $f!=$db_name && $f!='update.php' && $f!='server.config.bak') {
					if($delete===true) {
						if($f=='server.config') {
							copy($folder.$f, $folder.$f.'.bak');
						}
						unlink($folder.$f);
						@rmdir($folder);
					}
				}
			}
			else {
				@mkdir($backup_folder.$f, 0777, true);
				chmod($backup_folder.$f, 0777);
				backup($folder.$f.'/', $backup_folder.$f.'/', $delete);
				if($f!='db' && $f!='.git') {
					if($delete===true) {
						@rmdir($folder.$f);
					}
				}
			}
		}
	}
}

function server_config($folder) {
	$dirs=scandir($folder);
	if(!is_array($dirs)) return;
	foreach ($dirs as $d) {
		$f=$folder.'/'.$d;
		if(is_dir($f)) {
			if(file_exists($f.'/server.config') && file_exists($f.'/server.config.bak')) {
				rename($f.'/server.config', $f.'/server.config.default');
				rename($f.'/server.config.bak', $f.'/server.config');
			}
		}
	}
}

if($backup=='true') {
	// Делаем бэкап
	if(!file_exists($dir)) {
		mkdir($dir, 0777, true);
		chmod($dir, 0777);
	}
	if(!file_exists($backup_folder)) {
		mkdir($backup_folder, 0777, true);
		chmod($backup_folder, 0777);
	}
	backup($_SERVER["DOCUMENT_ROOT"].'/', $_SERVER["DOCUMENT_ROOT"].'/'.$backup_folder, false);
	header('Location: /update.php');
	exit();
}

if($result['success'] && $result['version']['version']==$instal) { // Установка обновления
	// Делаем бэкап
	if(!file_exists($dir)) {
		mkdir($dir, 0777, true);
		chmod($dir, 0777);
	}
	if(!file_exists($backup_folder)) {
		mkdir($backup_folder, 0777, true);
		chmod($backup_folder, 0777);
	}
	backup($_SERVER["DOCUMENT_ROOT"].'/', $_SERVER["DOCUMENT_ROOT"].'/'.$backup_folder, true);

	// Скачиваем архив с новой версией
	$ch = curl_init();
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_HEADER, false);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_URL, $result['version']['file']);
    curl_setopt($ch, CURLOPT_REFERER, $result['version']['file']);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
    $output = curl_exec($ch);
    curl_close($ch);
	$ext=pathinfo($result['version']['file'], PATHINFO_EXTENSION);
	$archive="next_version.".$ext;
	$fh = fopen($archive, 'w');
	fwrite($fh, $output);
	fclose($fh);

	// Распаковываем архив с новой версией
	$zip = new ZipArchive(); //Создаём объект для работы с ZIP-архивами
  	//Открываем архив archive.zip и делаем проверку успешности открытия
  	if($zip->open($archive)) {
    	$zip->extractTo($_SERVER["DOCUMENT_ROOT"]); //Извлекаем файлы в указанную директорию
    	$zip->close(); //Завершаем работу с архивом
    	unlink($archive);
    	if(file_exists('app/db_update.php')) {
    		// обновляем базу данных
    		$db = new SQLite3($ini['db_name'], SQLITE3_OPEN_READWRITE);
    		include('app/db_update.php');
    		unlink('app/db_update.php');
    	}
    	// Восстанавливаем настройки драйверов
    	server_config('drivers/displays');
    	server_config('drivers/printers');
    	header('Location: /update.php');
    	exit();
    }
    else {
    	echo "<p>Ошибка с архивом</p>";
    }
}

// Восстановление из бэкапа
if($instal && is_dir($dir.'/'.$instal)) {
	$bdb=$_GET['db'];
	// Удаляем все
	function delete_folders($folder) {
		global $bdb;
		$files=scandir($folder);
		foreach ($files as $f) {
			if($f!='.' && $f!='..' && $f!='backups') {
				if(!is_dir($folder.$f)) {
					unlink($folder.$f);
					@rmdir($folder);
				}
				else {
					if($bdb || $f!='db') {
						delete_folders($folder.$f.'/');
						@rmdir($folder.$f);
					}
				}
			}
		}
	}
	delete_folders($_SERVER["DOCUMENT_ROOT"].'/');

	// восстанавливаем из папки
	function restore($restore_folder, $folder) {
		global $bdb;
		$files=scandir($restore_folder);
		foreach ($files as $f) {
			if($f!='.' && $f!='..') {
				if(!is_dir($restore_folder.$f)) {
					if(!copy($restore_folder.$f, $folder.$f)) {
						echo'<p>Возникла ошибка при копировании файла '.$restore_folder.$f.'</p>';
						exit();
					}
				}
				else {
					if($bdb || $f!='db') {
						@mkdir($folder.$f, 0777, true);
						chmod($folder.$f, 0777);
						restore($restore_folder.$f.'/', $folder.$f.'/');
					}
				}
			}
		}
	}
	restore($_SERVER["DOCUMENT_ROOT"].'/'.$dir.'/'.$instal.'/', $_SERVER["DOCUMENT_ROOT"].'/');
	header('Location: /update.php');
	exit();
}

echo '<a href="/"><input type="button" value="Вернуться"></a>';
echo"<p>Текущая версия ".$version.". <a href='/update.php?backup=true'><input type=button value='Сделать резервную копию'></a></p>";
if($result['success']) {
	echo "<p>Доступно обновление ".$result['version']['title']." ".$result['version']['version']." <a href=/update.php?instal=".$result['version']['version']."><input type=button value=Установить></p></a>";
}
else {
	foreach ($result['error'] as $er) {
		echo $er;
	}
}

// Показываем предыдущии версии
if(file_exists($dir)) {
	$backups=scandir($dir);
	if(count($backups)>2) {
		echo"<br><p>Восстановить предыдущую версию</p>";
		foreach ($backups as $f) {
			if($f!='.' && $f!='..') {
				echo "<p>".$f.' <a href="/update.php?instal='.$f.'"><input type="button" value="Восстановить без БД"></a> <a href="/update.php?instal='.$f.'&db=1"><input type="button" value="Восстановить с БД"></a>';
			}
		}
	}
}
